(**********************************************************************)
(** - Copyright (C) 1991 Lehrstuhl III fuer Informatik, RWTH Aachen - *)
(** This library is free software; you can redistribute it and/or     *)
(** modify it under the terms of the GNU Library General Public       *)
(** License as published by the Free Software Foundation; either      *)
(** version 2 of the License, or (at your option) any later version.  *)
(** See the file COPYING.LIB for details.                             *)
(**                                                                   *)
(** Author of the generic parser: Frank Hoefer                        *)
(** For the Modula-2 to -3 converter: Peter Klein                     *)
(**********************************************************************)
MODULE M2toM3 EXPORTS Main;

IMPORT Parser;

IMPORT Wr, Rd, Text, Stdio, Params;


<* FATAL ANY *>


PROCEDURE Run (filename: TEXT) =
  VAR ok: BOOLEAN;

  BEGIN
    Parser.Check(filename, ok);
    Wr.PutText(Stdio.stdout, "\n");
    Wr.PutText(Stdio.stderr, filename);
    IF ok THEN
      Wr.PutText(Stdio.stderr, " converted.\n");
    ELSE
      Wr.PutText(Stdio.stderr, " aborted.\n");
    END;
  END Run;


VAR argString: TEXT;

BEGIN
  IF (Params.Count = 1) THEN
    Wr.PutText(Stdio.stdout, "Filename: ");
    Wr.Flush(Stdio.stdout);
    argString := Rd.GetLine(Stdio.stdin);
    Run(argString);
  ELSIF ((Params.Count = 2) AND Text.Equal(Params.Get(1), "-")) THEN
    Run("");
  ELSE
    FOR actualArgument := 1 TO Params.Count - 1 DO
      argString := Params.Get(actualArgument);
      Run(argString);
    END;
  END;
END M2toM3.
