(**********************************************************************)
(** - Copyright (C) 1991 Lehrstuhl III fuer Informatik, RWTH Aachen - *)
(** This library is free software; you can redistribute it and/or     *)
(** modify it under the terms of the GNU Library General Public       *)
(** License as published by the Free Software Foundation; either      *)
(** version 2 of the License, or (at your option) any later version.  *)
(** See the file COPYING.LIB for details.                             *)
(**                                                                   *)
(** Author of the generic parser: Frank Hoefer                        *)
(** For the Modula-2 to -3 converter: Peter Klein                     *)
(**********************************************************************)
INTERFACE Scanner;


EXCEPTION
  IOError(TEXT);
  ScanError;


TYPE
  TokenType =
    {NoToken, BadToken, Comment,

     Identifier, StringConst, IntegerConst, LongConst, RealConst,
     CharConst,

     Plus, Minus, Mult, Division, Assign, Ampersand,

     Period, Comma, Semicolon, LBracket, ALBracket, CLBracket, RBracket,
     ARBracket, CRBracket,

     Arrow, Equal, NEqual, Less, Greater, LEqual, GEqual,

     Range, Colon, Bar,

     And, Array, Begin, By, Case, Const, Definition, Div, Do, Else, Elsif,
     End, Exit, Export, For, Forward, From, If, Implementation, Import, In,
     Loop, Mod, Module, Not, Of, Or, Pointer, Procedure, Qualified, Rem,
     Record, Repeat, Return, Set, Then, To, Type, Until, Var, While, With,

     ImpArrow, Branded, Ref, Interface, EmptyString};


VAR
  lookahead: TokenType;
  name     : TEXT;
  line     : CARDINAL;


PROCEDURE Init (name: TEXT) RAISES {IOError};


PROCEDURE Exit () RAISES {IOError};


PROCEDURE Match (wanted, write: TokenType) RAISES {IOError, ScanError};

END Scanner.
